Skip to content
Snippets Groups Projects
Commit a3f8dd9c authored by gengdongjie's avatar gengdongjie
Browse files

upload c3d

parent 03ac2c1b
No related branches found
No related tags found
No related merge requests found
Showing
with 1767 additions and 0 deletions
This diff is collapsed.
cmake_minimum_required(VERSION 3.14.1)
project(Ascend310Infer)
add_compile_definitions(_GLIBCXX_USE_CXX11_ABI=0)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -std=c++17 -Werror -Wall -fPIE -Wl,--allow-shlib-undefined")
set(PROJECT_SRC_ROOT ${CMAKE_CURRENT_LIST_DIR}/)
option(MINDSPORE_PATH "mindspore install path" "")
include_directories(${MINDSPORE_PATH})
include_directories(${MINDSPORE_PATH}/include)
include_directories(${PROJECT_SRC_ROOT})
find_library(MS_LIB libmindspore.so ${MINDSPORE_PATH}/lib)
file(GLOB_RECURSE MD_LIB ${MINDSPORE_PATH}/_c_dataengine*)
add_executable(main src/main.cc src/utils.cc)
target_link_libraries(main ${MS_LIB} ${MD_LIB} gflags)
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
if [ -d out ]; then
rm -rf out
fi
mkdir out
cd out || exit
if [ -f "Makefile" ]; then
make clean
fi
cmake .. \
-DMINDSPORE_PATH="`pip3.7 show mindspore-ascend | grep Location | awk '{print $2"/mindspore"}' | xargs realpath`"
make
/**
* Copyright 2021 Huawei Technologies Co., Ltd
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
#ifndef MINDSPORE_INFERENCE_UTILS_H_
#define MINDSPORE_INFERENCE_UTILS_H_
#include <sys/stat.h>
#include <dirent.h>
#include <vector>
#include <string>
#include <memory>
#include "include/api/types.h"
std::vector<std::string> GetAllFiles(std::string_view dirName);
DIR *OpenDir(std::string_view dirName);
std::string RealPath(std::string_view path);
mindspore::MSTensor ReadFileToTensor(const std::string &file);
int WriteResult(const std::string& imageFile, const std::vector<mindspore::MSTensor> &outputs);
#endif
/**
* Copyright 2021 Huawei Technologies Co., Ltd
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
#include <sys/time.h>
#include <gflags/gflags.h>
#include <dirent.h>
#include <iostream>
#include <string>
#include <algorithm>
#include <iosfwd>
#include <vector>
#include <fstream>
#include <sstream>
#include "include/api/model.h"
#include "include/api/context.h"
#include "include/api/types.h"
#include "include/api/serialization.h"
#include "include/dataset/execute.h"
#include "include/dataset/vision.h"
#include "inc/utils.h"
using mindspore::Context;
using mindspore::Serialization;
using mindspore::Model;
using mindspore::Status;
using mindspore::MSTensor;
using mindspore::dataset::Execute;
using mindspore::ModelType;
using mindspore::GraphCell;
using mindspore::kSuccess;
DEFINE_string(mindir_path, "", "mindir path");
DEFINE_string(input0_path, ".", "input0 path");
DEFINE_int32(device_id, 0, "device id");
int main(int argc, char **argv) {
gflags::ParseCommandLineFlags(&argc, &argv, true);
if (RealPath(FLAGS_mindir_path).empty()) {
std::cout << "Invalid mindir" << std::endl;
return 1;
}
auto context = std::make_shared<Context>();
auto ascend310 = std::make_shared<mindspore::Ascend310DeviceInfo>();
ascend310->SetDeviceID(FLAGS_device_id);
context->MutableDeviceInfo().push_back(ascend310);
mindspore::Graph graph;
Serialization::Load(FLAGS_mindir_path, ModelType::kMindIR, &graph);
std::cout << "Start Build Model." << std::endl;
Model model;
Status ret = model.Build(GraphCell(graph), context);
if (ret != kSuccess) {
std::cout << "ERROR: Build failed." << std::endl;
return 1;
}
std::vector<MSTensor> model_inputs = model.GetInputs();
if (model_inputs.empty()) {
std::cout << "Invalid model, inputs is empty." << std::endl;
return 1;
}
auto input0_files = GetAllFiles(FLAGS_input0_path);
if (input0_files.empty()) {
std::cout << "ERROR: input data empty." << std::endl;
return 1;
}
std::map<double, double> costTime_map;
size_t size = input0_files.size();
for (size_t i = 0; i < size; ++i) {
struct timeval start = {0};
struct timeval end = {0};
double startTimeMs;
double endTimeMs;
std::vector<MSTensor> inputs;
std::vector<MSTensor> outputs;
std::cout << "Start predict input files:" << input0_files[i] << std::endl;
auto input0 = ReadFileToTensor(input0_files[i]);
std::cout << "666" << input0_files[i] << std::endl;
inputs.emplace_back(model_inputs[0].Name(), model_inputs[0].DataType(), model_inputs[0].Shape(),
input0.Data().get(), input0.DataSize());
gettimeofday(&start, nullptr);
ret = model.Predict(inputs, &outputs);
gettimeofday(&end, nullptr);
if (ret != kSuccess) {
std::cout << "Predict " << input0_files[i] << " failed." << std::endl;
return 1;
}
startTimeMs = (1.0 * start.tv_sec * 1000000 + start.tv_usec) / 1000;
endTimeMs = (1.0 * end.tv_sec * 1000000 + end.tv_usec) / 1000;
costTime_map.insert(std::pair<double, double>(startTimeMs, endTimeMs));
WriteResult(input0_files[i], outputs);
}
double average = 0.0;
int inferCount = 0;
for (auto iter = costTime_map.begin(); iter != costTime_map.end(); iter++) {
double diff = 0.0;
diff = iter->second - iter->first;
average += diff;
inferCount++;
}
average = average / inferCount;
std::stringstream timeCost;
timeCost << "NN inference cost average time: "<< average << " ms of infer_count " << inferCount << std::endl;
std::cout << "NN inference cost average time: "<< average << "ms of infer_count " << inferCount << std::endl;
std::string fileName = "./time_Result" + std::string("/test_perform_static.txt");
std::ofstream fileStream(fileName.c_str(), std::ios::trunc);
fileStream << timeCost.str();
fileStream.close();
costTime_map.clear();
return 0;
}
/**
* Copyright 2021 Huawei Technologies Co., Ltd
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
#include <fstream>
#include <algorithm>
#include <iostream>
#include "inc/utils.h"
using mindspore::MSTensor;
using mindspore::DataType;
std::vector<std::string> GetAllFiles(std::string_view dirName) {
struct dirent *filename;
DIR *dir = OpenDir(dirName);
if (dir == nullptr) {
return {};
}
std::vector<std::string> res;
while ((filename = readdir(dir)) != nullptr) {
std::string dName = std::string(filename->d_name);
if (dName == "." || dName == ".." || filename->d_type != DT_REG) {
continue;
}
res.emplace_back(std::string(dirName) + "/" + filename->d_name);
}
std::sort(res.begin(), res.end());
for (auto &f : res) {
std::cout << "image file: " << f << std::endl;
}
return res;
}
int WriteResult(const std::string& imageFile, const std::vector<MSTensor> &outputs) {
std::string homePath = "./result_Files";
for (size_t i = 0; i < outputs.size(); ++i) {
size_t outputSize;
std::shared_ptr<const void> netOutput;
netOutput = outputs[i].Data();
outputSize = outputs[i].DataSize();
int pos = imageFile.rfind('/');
std::string fileName(imageFile, pos + 1);
fileName.replace(fileName.find('.'), fileName.size() - fileName.find('.'), '_' + std::to_string(i) + ".bin");
std::string outFileName = homePath + "/" + fileName;
FILE * outputFile = fopen(outFileName.c_str(), "wb");
fwrite(netOutput.get(), outputSize, sizeof(char), outputFile);
fclose(outputFile);
outputFile = nullptr;
}
return 0;
}
mindspore::MSTensor ReadFileToTensor(const std::string &file) {
if (file.empty()) {
std::cout << "Pointer file is nullptr" << std::endl;
return mindspore::MSTensor();
}
std::ifstream ifs(file);
if (!ifs.good()) {
std::cout << "File: " << file << " is not exist" << std::endl;
return mindspore::MSTensor();
}
if (!ifs.is_open()) {
std::cout << "File: " << file << "open failed" << std::endl;
return mindspore::MSTensor();
}
ifs.seekg(0, std::ios::end);
size_t size = ifs.tellg();
mindspore::MSTensor buffer(file, mindspore::DataType::kNumberTypeUInt8, {static_cast<int64_t>(size)}, nullptr, size);
ifs.seekg(0, std::ios::beg);
ifs.read(reinterpret_cast<char *>(buffer.MutableData()), size);
ifs.close();
return buffer;
}
DIR *OpenDir(std::string_view dirName) {
if (dirName.empty()) {
std::cout << " dirName is null ! " << std::endl;
return nullptr;
}
std::string realPath = RealPath(dirName);
struct stat s;
lstat(realPath.c_str(), &s);
if (!S_ISDIR(s.st_mode)) {
std::cout << "dirName is not a valid directory !" << std::endl;
return nullptr;
}
DIR *dir;
dir = opendir(realPath.c_str());
if (dir == nullptr) {
std::cout << "Can not open dir " << dirName << std::endl;
return nullptr;
}
std::cout << "Successfully opened the dir " << dirName << std::endl;
return dir;
}
std::string RealPath(std::string_view path) {
char realPathMem[PATH_MAX] = {0};
char *realPathRet = nullptr;
realPathRet = realpath(path.data(), realPathMem);
if (realPathRet == nullptr) {
std::cout << "File: " << path << " is not exist.";
return "";
}
std::string realPath(realPathMem);
std::cout << path << " realpath is: " << realPath << std::endl;
return realPath;
}
# Device
device_target: "Ascend"
# ==============================================================================
# Dataset Setup
clip_length: 16 # Number of frames within a clip
clip_offset: 0 # Frame offset between beginning of video and clip (1st clip only)
clip_stride: 1 # Frame offset between successive clips, must be >= 1
crop_shape: [112,112] # (Height, Width) of frame
crop_type: Random # Type of cropping operation (Random, Central and None)
final_shape: [112,112] # (Height, Width) of input to be given to CNN
num_clips: -1 # Number clips to be generated from a video (<0: uniform sampling, 0: Divide entire video into clips, >0: Defines number of clips)
random_offset: 0 # Boolean switch to generate a clip length sized clip from a video
resize_shape: [128,171] # (Height, Width) to resize original data
subtract_mean: '' # Subtract mean (R,G,B) from all frames during preprocessing
preprocess: default # String argument to select preprocessing type
# Experiment Setup
model: C3D # Name of model to be loaded
acc_metric: Accuracy # Accuracy metric
batch_size: 16 # Numbers of videos in a mini-batch
dataset: HMDB51 # Name of dataset, 'HMDB51' or 'UCF101'
epoch: 30 # Total number of epochs
gamma: 0.1 # Multiplier with which to change learning rate
json_path: /Data/hmdb-51_json/ # Path to the json file for the given dataset
img_path: /Data/hmdb-51_img/ # Path to the img file for the given dataset
pre_trained: 1 # Load pretrained network
pre_trained_ckpt_path : ./pretrained_model/pre_trained_model.ckpt # pre_trained model ckpt file path
sport1m_mean_file_path: ./pretrained_model/sport1m_train16_128_mean.npy # Sport1m data distribution information
num_classes: 51 # Number of total classes in the dataset, 51 for HMDB51 and 101 for UCF101
loss_type: M_XENTROPY # Loss function
lr: 1e-4 # Learning rate
milestones: [10, 20] # Epoch values to change learning rate
momentum: 0.9 # Momentum value in optimizer
loss_scale: 1.0
num_workers: 8 # Number of CPU worker used to load data
opt: sgd # Name of optimizer
save_dir: ./results # Path to results directory
seed: 666 # Seed for reproducibility
weight_decay: 0.0005 # Weight decay
# Train Setup
is_distributed: 0 # Distributed training or not
is_save_on_master: 1 # Only save ckpt on master device
device_id: 0 # Device id
ckpt_path: ./result/ckpt # Ckpt save path
ckpt_interval: 1 # Saving ckpt interval
keep_checkpoint_max: 40 # Max ckpt file number
# Modelarts Setup
enable_modelarts: 0 # Is training on modelarts
result_url: '' # Result save path
data_url: '' # Data path
train_url: '' # Train path
# Export Setup
ckpt_file: './C3D.ckpt' # Mindspore ckpt file path
mindir_file_name: './C3D' # Save file path
file_format: 'mindir' # Save file format
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
import os
import datetime
import numpy as np
import mindspore.nn as nn
from mindspore import Tensor
from mindspore import context
from mindspore.train.serialization import load_param_into_net, load_checkpoint
from mindspore.common import set_seed
from src.dataset import classification_dataset
from src.c3d_model import C3D
from src.model_utils.config import config
class TestOneStepCell(nn.Cell):
def __init__(self, network, criterion):
super(TestOneStepCell, self).__init__(auto_prefix=False)
self.network = network
self.criterion = criterion
def construct(self, data, label):
output = self.network(data)
loss = self.criterion(output, label)
return output, loss
def test_net():
'''run test'''
config.load_type = 'test'
set_seed(config.seed)
context.set_context(mode=context.GRAPH_MODE, enable_graph_kernel=False,
device_target=config.device_target)
if config.device_target == "Ascend":
context.set_context(device_id=config.device_id)
# logger
config.outputs_dir = os.path.join(config.save_dir, datetime.datetime.now().strftime('%Y-%m-%d_time_%H_%M_%S'))
dataset, _ = classification_dataset(config.batch_size, shuffle=False, repeat_num=1,
drop_remainder=False)
batch_num = dataset.get_dataset_size()
config.steps_per_epoch = dataset.get_dataset_size()
# network
print('start create network')
network = C3D(config.num_classes)
# pre_trained
param_dict = load_checkpoint(config.ckpt_path)
_ = load_param_into_net(network, param_dict)
print('pre_trained model:', config.ckpt_path)
network.set_train(mode=False)
acc_sum, sample_num = 0, 0
for index, (input_data, label) in enumerate(dataset):
predictions = network(Tensor(input_data))
predictions, label = predictions.asnumpy(), label.asnumpy()
acc = np.sum(np.argmax(predictions, 1) == label[:, -1])
batch_size = label.shape[0]
acc_sum += acc
sample_num += batch_size
if index % 20 == 0:
print("setep: {}/{}, acc: {}".format(index + 1, batch_num, acc / batch_size))
accuracy_top1 = acc_sum / sample_num
print('eval result: top_1 {:.3f}%'.format(accuracy_top1 * 100))
if __name__ == '__main__':
test_net()
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
import numpy as np
from mindspore import dtype as mstype
from mindspore import context, Tensor, export
from mindspore.train.serialization import load_checkpoint, load_param_into_net
from src.c3d_model import C3D
from src.model_utils.config import config
from src.model_utils.moxing_adapter import moxing_wrapper
@moxing_wrapper()
def export_model(ckpt_path):
network = C3D(num_classes=config.num_class)
network.set_train(False)
param_dict = load_checkpoint(ckpt_path)
load_param_into_net(network, param_dict)
image_shape = [config.batch_size, 3, config.clip_length] + config.final_shape
window_image = Tensor(np.zeros(image_shape), mstype.float32)
export(network, window_image, file_name=config.mindir_file_name, file_format=config.file_format)
if __name__ == '__main__':
context.set_context(mode=context.GRAPH_MODE, device_target=config.device_target,
save_graphs=False, device_id=config.device_id)
export_model(ckpt_path=config.ckpt_file)
nibabel
pyyaml
opencv-python
\ No newline at end of file
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
if [ $# -lt 1 ] || [ $# -gt 2 ]; then
echo "Usage: bash run_ckpt_convert.sh [PYTORCH_FILE_PATH] [MINDSPORE_FILE_PATH]
PYTORCH_FILE_PATH is pytorch pretrained model ckpt file path.
MINDSPORE_FILE_PATH is mindspore pretrained model ckpt file path."
exit 1
fi
get_real_path(){
if [ "${1:0:1}" == "/" ]; then
echo "$1"
else
echo "$(realpath -m $PWD/$1)"
fi
}
torch_file_path=$(get_real_path $1)
if [ ! -f ${torch_file_path} ]; then
echo "Pytorch pretrained model ckpt file path does not exist."
exit 1
fi
mindspore_file_path=$(get_real_path $2)
cd ..
python3.7 -m src.tools.ckpt_convert ${torch_file_path} ${mindspore_file_path}
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
if [ $# -lt 2 ] || [ $# -gt 3 ]; then
echo "Usage: bash run_dataset_preprocess.sh [DATASET_NAME] [RAR_FILE_PATH] [SPLIT_NUMBER]
DATASET_NAME is the dataset name, it's value is 'HMDB51' or 'UCF101'.
RAR_FILE_PATH is raw rar(or zip) file path
SPLIT_NUMBER is the split number, it's value is '1', '2' or '3'."
exit 1
fi
if [ $1 != 'HMDB51' ] && [ $1 != 'UCF101' ]; then
echo "DATASET_NAME must be 'HMDB51' or 'UCF101'."
exit 1
fi
if [ "${2:0:1}" != "/" ]; then
echo "Please change $2 to an absolute path."
exit 1
fi
if [ ! -f $2 ]; then
echo "dataset rar file path does not exist."
exit 1
fi
if [ $3 -ne 1 ] && [ $3 -ne 2 ] && [ $3 -ne 3 ]; then
echo "SPLIT_NUMBER must be '1', '2' or '3'."
exit 1
fi
get_real_path(){
if [ "${1:0:1}" == "/" ]; then
echo $1
else
echo "$(realpath -m ${PWD}/$1)"
fi
}
dataset_rar_file_path=$(get_real_path $2)
if [ ! -f ${dataset_rar_file_path} ]; then
echo "Dataset rar file path does not exist!"
exit 1
fi
python3.7 ../src/tools/dataset_preprocess.py $1 ${dataset_rar_file_path} $3
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
# bash run_distribute_train_ascend.sh [RANK_TABLE_FILE]
if [ $# -ne 1 ]; then
echo "Usage: bash run_distribute_train_ascend.sh [RANK_TABLE_FILE]"
exit 1
fi
get_real_path(){
if [ "${1:0:1}" == "/" ]; then
echo $1
else
echo "$(realpath -m ${PWD}/$1)"
fi
}
PATH1=$(get_real_path $1)
if [ ! -f ${PATH1} ]; then
echo "error: RANK_TABLE_FILE=$PATH1 is not a file."
exit 1
fi
cd ..
export RANK_SIZE=8
export RANK_TABLE_FILE=$PATH1
echo 'start training'
for((i=0;i<=$RANK_SIZE-1;i++));
do
export DEVICE_ID=$i
export RANK_ID=$i
rm -rf ./train_parallel$i
mkdir ./train_parallel$i
cp ./*.py ./train_parallel$i
cp ./*.yaml ./train_parallel$i
cp -r ./src ./train_parallel$i
cd ./train_parallel$i || exit
echo "start training for rank $RANK_ID, device $DEVICE_ID"
env > env.log
python train.py --is_distributed 1 > ./train$i.log 2>&1 &
cd ../
done
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
if [[ $# -lt 2 || $# -gt 3 ]]; then
echo "Usage: bash run_infer_310.sh [MINDIR_PATH] [NEED_PREPROCESS] [DEVICE_ID]
NEED_PREPROCESS means weather need preprocess or not, it's value is 'y' or 'n'.
DEVICE_ID is optional, it can be set by environment variable device_id, otherwise the value is zero"
exit 1
fi
get_real_path(){
if [ "${1:0:1}" == "/" ]; then
echo "$1"
else
echo "$(realpath -m $PWD/$1)"
fi
}
model=$(get_real_path $1)
if [ "$2" == "y" ] || [ "$2" == "n" ];then
need_preprocess=$2
else
echo "weather need preprocess or not, it's value must be in [y, n]"
exit 1
fi
device_id=0
if [ $# == 3 ]; then
device_id=$3
fi
echo "mindir name: "$model
echo "need preprocess: "$need_preprocess
echo "device id: "$device_id
export ASCEND_HOME=/usr/local/Ascend/
if [ -d ${ASCEND_HOME}/ascend-toolkit ]; then
export PATH=$ASCEND_HOME/fwkacllib/bin:$ASCEND_HOME/fwkacllib/ccec_compiler/bin:$ASCEND_HOME/ascend-toolkit/latest/fwkacllib/ccec_compiler/bin:$ASCEND_HOME/ascend-toolkit/latest/atc/bin:$PATH
export LD_LIBRARY_PATH=$ASCEND_HOME/fwkacllib/lib64:/usr/local/lib:$ASCEND_HOME/ascend-toolkit/latest/atc/lib64:$ASCEND_HOME/ascend-toolkit/latest/fwkacllib/lib64:$ASCEND_HOME/driver/lib64:$ASCEND_HOME/add-ons:$LD_LIBRARY_PATH
export TBE_IMPL_PATH=$ASCEND_HOME/ascend-toolkit/latest/opp/op_impl/built-in/ai_core/tbe
export PYTHONPATH=$ASCEND_HOME/fwkacllib/python/site-packages:${TBE_IMPL_PATH}:$ASCEND_HOME/ascend-toolkit/latest/fwkacllib/python/site-packages:$PYTHONPATH
export ASCEND_OPP_PATH=$ASCEND_HOME/ascend-toolkit/latest/opp
else
export PATH=$ASCEND_HOME/fwkacllib/bin:$ASCEND_HOME/fwkacllib/ccec_compiler/bin:$ASCEND_HOME/atc/ccec_compiler/bin:$ASCEND_HOME/atc/bin:$PATH
export LD_LIBRARY_PATH=$ASCEND_HOME/fwkacllib/lib64:/usr/local/lib:$ASCEND_HOME/atc/lib64:$ASCEND_HOME/acllib/lib64:$ASCEND_HOME/driver/lib64:$ASCEND_HOME/add-ons:$LD_LIBRARY_PATH
export PYTHONPATH=$ASCEND_HOME/fwkacllib/python/site-packages:$ASCEND_HOME/atc/python/site-packages:$PYTHONPATH
export ASCEND_OPP_PATH=$ASCEND_HOME/opp
fi
function preprocess_data()
{
if [ -d preprocess_Result ]; then
rm -rf ./preprocess_Result
fi
mkdir preprocess_Result
python3.7 ../preprocess.py
}
function compile_app()
{
cd ../ascend310_infer || exit
bash build.sh &> build.log
}
function infer()
{
cd - || exit
if [ -d result_Files ]; then
rm -rf ./result_Files
fi
if [ -d time_Result ]; then
rm -rf ./time_Result
fi
mkdir result_Files
mkdir time_Result
../ascend310_infer/out/main --mindir_path=$model --input0_path=./preprocess_Result/image --device_id=$device_id &> infer.log
}
function cal_acc()
{
python3.7 ../postprocess.py &> acc.log
}
if [ $need_preprocess == "y" ]; then
preprocess_data
if [ $? -ne 0 ]; then
echo "preprocess dataset failed"
exit 1
fi
fi
compile_app
if [ $? -ne 0 ]; then
echo "compile app code failed"
exit 1
fi
infer
if [ $? -ne 0 ]; then
echo " execute inference failed"
exit 1
fi
# cal_acc
if [ $? -ne 0 ]; then
echo "calculate accuracy failed"
exit 1
fi
\ No newline at end of file
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
if [ $# -lt 1 ]; then
echo "Usage: bash run_standalone_eval_ascend.sh [CKPT_FILE_PATH]
CKPT_FILE_PATH is saved model ckpt file path."
exit 1
fi
get_real_path(){
if [ "${1:0:1}" == "/" ]; then
echo "$1"
else
echo "$(realpath -m $PWD/$1)"
fi
}
ckpt_path=$(get_real_path $1)
if [ ! -f ${ckpt_path} ]; then
echo "Ckpt file does not exist."
exit 1
fi
cd ../
python eval.py --ckpt_path ${ckpt_path} > eval.log 2>&1 &
#!/bin/bash
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
# bash run_standalone_train_ascend.sh
cd ..
python train.py > train.log 2>&1 &
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
import math
import mindspore.nn as nn
import mindspore.ops as P
from mindspore.common import initializer as init
from src.utils import default_recurisive_init, KaimingNormal
class C3D(nn.Cell):
"""
C3D network definition.
Args:
num_classes (int): Class numbers. Default: 1000.
Returns:
Tensor, infer output tensor.
Examples:
>>> C3D(num_classes=1000)
"""
def __init__(self, num_classes=1000):
super(C3D, self).__init__()
self.conv1 = nn.Conv3d(in_channels=3, out_channels=64, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.pool1 = P.MaxPool3D(kernel_size=(1, 2, 2), strides=(1, 2, 2), pad_mode='same')
self.conv2 = nn.Conv3d(in_channels=64, out_channels=128, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.pool2 = P.MaxPool3D(kernel_size=(2, 2, 2), strides=(2, 2, 2), pad_mode='same')
self.conv3a = nn.Conv3d(in_channels=128, out_channels=256, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.conv3b = nn.Conv3d(in_channels=256, out_channels=256, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.pool3 = P.MaxPool3D(kernel_size=(2, 2, 2), strides=(2, 2, 2), pad_mode='same')
self.conv4a = nn.Conv3d(in_channels=256, out_channels=512, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.conv4b = nn.Conv3d(in_channels=512, out_channels=512, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.pool4 = P.MaxPool3D(kernel_size=(2, 2, 2), strides=(2, 2, 2), pad_mode='same')
self.conv5a = nn.Conv3d(in_channels=512, out_channels=512, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.conv5b = nn.Conv3d(in_channels=512, out_channels=512, kernel_size=(3, 3, 3),
padding=(1, 1, 1, 1, 1, 1), pad_mode='pad', has_bias=True)
self.pool5 = P.MaxPool3D(kernel_size=(2, 2, 2), strides=(2, 2, 2), pad_mode='same')
self.fc6 = nn.Dense(in_channels=8192, out_channels=4096)
self.fc7 = nn.Dense(in_channels=4096, out_channels=4096)
self.fc8 = nn.Dense(in_channels=4096, out_channels=num_classes, bias_init=init.Normal(0.02))
self.dropout = nn.Dropout(keep_prob=0.5)
self.relu = nn.ReLU()
self.pad = nn.Pad(paddings=((0, 0), (0, 0), (1, 0), (1, 0)), mode="CONSTANT")
self.__init_weight()
def __init_weight(self):
default_recurisive_init(self)
self.custom_init_weight()
def construct(self, x):
x = self.relu(self.conv1(x))
x = self.pool1(x)
x = self.relu(self.conv2(x))
x = self.pool2(x)
x = self.relu(self.conv3a(x))
x = self.relu(self.conv3b(x))
x = self.pool3(x)
x = self.relu(self.conv4a(x))
x = self.relu(self.conv4b(x))
x = self.pool4(x)
x = self.relu(self.conv5a(x))
x = self.relu(self.conv5b(x))
x = x.view(-1, 512 * 2, 7, 7)
x = self.pad(x)
x = x.view(-1, 512, 2, 8, 8)
x = self.pool5(x)
x = x.view(-1, 8192)
x = self.relu(self.fc6(x))
x = self.dropout(x)
x = self.relu(self.fc7(x))
x = self.dropout(x)
logits = self.fc8(x)
return logits
def custom_init_weight(self):
"""
Init the weight of Conv3d and Dense in the net.
"""
for _, cell in self.cells_and_names():
if isinstance(cell, nn.Conv3d):
cell.weight.set_data(init.initializer(
KaimingNormal(a=math.sqrt(5), mode='fan_out', nonlinearity='relu'),
cell.weight.shape, cell.weight.dtype))
if cell.bias is not None:
cell.bias.set_data(init.initializer(
'zeros', cell.bias.shape, cell.bias.dtype))
elif isinstance(cell, nn.Dense):
cell.weight.set_data(init.initializer(
init.Normal(0.01), cell.weight.shape, cell.weight.dtype))
if cell.bias is not None:
cell.bias.set_data(init.initializer(
'zeros', cell.bias.shape, cell.bias.dtype))
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
import os
import json
import cv2
import numpy as np
from PIL import ImageFile
import mindspore.dataset as de
from src.model_utils.config import config
from src.transform import PreprocessTrainC3D, PreprocessEvalC3D
ImageFile.LOAD_TRUNCATED_IMAGES = True
class video_Dataset():
def __init__(self):
self.load_type = config.load_type
self.crop_shape = config.crop_shape
self.final_shape = config.final_shape
self.preprocess = config.preprocess
self.json_path = config.json_path
self.img_path = config.img_path
# Clips processing arguments
self.clip_length = config.clip_length
self.clip_offset = config.clip_offset
self.clip_stride = config.clip_stride
self.num_clips = config.num_clips
self.random_offset = config.random_offset
# Frame-wise processing arguments
self.resize_shape = config.resize_shape
self.crop_type = config.crop_type
# Experiment arguments
self.batch_size = config.batch_size
self.class_number = config.num_classes
self._index = 0
if self.load_type == 'train':
self.transforms = PreprocessTrainC3D()
else:
self.transforms = PreprocessEvalC3D()
self._getClips()
def __getitem__(self, idx):
vid_info = self.samples[idx]
base_path = os.path.join(self.img_path, vid_info['base_path'])
vid_length = len(vid_info['frames'])
labels = np.zeros((vid_length)) - 1
input_data = []
for frame_ind in range(len(vid_info['frames'])):
frame_path = os.path.join(base_path, vid_info['frames'][frame_ind]['img_path'])
for frame_labels in vid_info['frames'][frame_ind]['actions']:
labels[frame_ind] = frame_labels['action_class']
# Load frame image data and preprocess image accordingly
input_data.append(cv2.imread(frame_path)[..., ::-1] / 1.)
# Preprocess data
vid_data = self.transforms(input_data)
vid_data = np.transpose(vid_data, (3, 0, 1, 2))
if self.load_type == 'train':
one_hot = np.zeros((self.class_number))
one_hot[labels.astype('int32')[-1]] = 1.
labels = one_hot
return (vid_data.astype(np.float32), labels.astype(np.int32))
def __len__(self):
return len(self.samples)
def __iter__(self):
self._index = 0
return self
def __next__(self):
# pylint: disable = no-else-return
if self._index < len(self.samples):
item = self.__getitem__(self._index)
self._index += 1
return item
else:
raise StopIteration
def _getClips(self):
self.samples = []
if self.load_type == 'train':
full_json_path = os.path.join(self.json_path, 'train.json')
elif self.load_type == 'val':
full_json_path = os.path.join(self.json_path, 'val.json')
if not os.path.exists(full_json_path):
full_json_path = os.path.join(self.json_path, 'test.json')
else:
full_json_path = os.path.join(self.json_path, 'test.json')
json_file = open(full_json_path, 'r')
json_data = json.load(json_file)
json_file.close()
# Load the information for each video and process it into clips
for video_info in json_data:
clips = self._extractClips(video_info['frames'])
# Each clip is a list of dictionaries per frame containing information
# Example info: object bbox annotations, object classes, frame img path
for clip in clips:
self.samples.append(dict(frames=clip, base_path=video_info['base_path']))
def _extractClips(self, video):
"""
Processes a single video into uniform sized clips that will be loaded by __getitem__
Args:
video: List containing a dictionary of annontations per frame
Additional Parameters:
self.clip_length: Number of frames extracted from each clip
self.num_clips: Number of clips to extract from each video
(-1 uses the entire video, 0 paritions the entire video in clip_length clips)
self.clip_offset: Number of frames from beginning of video to start extracting clips
self.clip_stride: Number of frames between clips when extracting them from videos
self.random_offset: Randomly select a clip_length sized clip from a video
"""
if self.clip_offset > 0:
if len(video) - self.clip_offset >= self.clip_length:
video = video[self.clip_offset:]
if self.num_clips < 0:
if len(video) >= self.clip_length:
# Uniformly sample one clip from the video
final_video = [video[_idx] for _idx in np.linspace(0, len(video) - 1, self.clip_length, dtype='int32')]
final_video = [final_video]
else:
indices = np.ceil(self.clip_length / float(len(video)))
indices = indices.astype('int32')
indices = np.tile(np.arange(0, len(video), 1, dtype='int32'), indices)
indices = indices[np.linspace(0, len(indices) - 1, self.clip_length, dtype='int32')]
final_video = [video[_idx] for _idx in indices]
final_video = [final_video]
elif self.num_clips == 0:
if len(video) >= self.clip_length:
indices = np.arange(start=0, stop=len(video) - self.clip_length + 1, step=self.clip_stride)
final_video = []
for _idx in indices:
if _idx + self.clip_length <= len(video):
final_video.append([video[true_idx] for true_idx in range(_idx, _idx + self.clip_length)])
else:
indices = np.ceil(self.clip_length / float(len(video)))
indices = indices.astype('int32')
indices = np.tile(np.arange(0, len(video), 1, dtype='int32'), indices)
indices = indices[:self.clip_length]
final_video = [video[_idx] for _idx in indices]
final_video = [final_video]
else:
if self.clip_length == -1:
# This is a special case where we will return the entire video
# Batch size must equal one or dataloader items may have varying lengths
# and can't be stacked i.e. throws an error
assert self.batch_size == 1
return [video]
required_length = (self.num_clips - 1) * (self.clip_stride) + self.clip_length
if self.random_offset:
if len(video) >= required_length:
vid_start = np.random.choice(np.arange(len(video) - required_length + 1), 1)
video = video[int(vid_start):]
if len(video) >= required_length:
# Get indices of sequential clips overlapped by a clip_stride number of frames
indices = np.arange(0, len(video), self.clip_stride)
# Select only the first num clips
indices = indices.astype('int32')[:self.num_clips]
video = np.array(video)
final_video = [video[np.arange(_idx, _idx + self.clip_length).astype('int32')].tolist() for _idx in
indices]
else:
indices = np.ceil(required_length / float(len(video)))
indices = indices.astype('int32')
indices = np.tile(np.arange(0, len(video), 1, dtype='int32'), indices)
# Starting index of each clip
clip_starts = np.arange(0, len(indices), self.clip_stride).astype('int32')[:self.num_clips]
video = np.array(video)
final_video = [video[indices[_idx:_idx + self.clip_length]].tolist() for _idx in clip_starts]
return final_video
def classification_dataset(per_batch_size, shuffle=None, repeat_num=1, drop_remainder=True):
dataset = video_Dataset()
dataset_len = len(dataset)
if shuffle:
num_parallel_workers = config.num_workers
if config.is_distributed:
de_dataset = de.GeneratorDataset(dataset, ["video", "label"], num_parallel_workers=num_parallel_workers,
shuffle=shuffle, num_shards=config.group_size, shard_id=config.rank)
else:
de_dataset = de.GeneratorDataset(dataset, ["video", "label"], num_parallel_workers=num_parallel_workers,
shuffle=shuffle)
else:
num_parallel_workers = 1
de_dataset = de.GeneratorDataset(dataset, ["video", "label"], num_parallel_workers=num_parallel_workers,
shuffle=shuffle)
columns_to_project = ["video", "label"]
de_dataset = de_dataset.project(columns=columns_to_project)
de_dataset = de_dataset.batch(per_batch_size, drop_remainder=drop_remainder)
de_dataset = de_dataset.repeat(repeat_num)
return de_dataset, dataset_len
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
from mindspore.nn.loss.loss import LossBase
from mindspore.ops import operations as P
import mindspore.nn as nn
class Max_Entropy(LossBase):
def __init__(self, reduction='mean'):
super(Max_Entropy, self).__init__(reduction)
self.logsoftmax = nn.LogSoftmax(axis=1)
self.sum = P.ReduceSum()
self.mean = P.ReduceMean()
def construct(self, predictions, targets):
log = self.logsoftmax(predictions)
temp_ = self.sum(-targets * log, 1)
loss = self.mean(temp_)
return self.get_loss(loss)
# Copyright 2021 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
import numpy as np
def linear_warmup_learning_rate(lr_max, epoch_step, global_step=0, lr_init=1e-8,
warmup_epochs=0, total_epochs=1, steps_per_epoch=1):
"""Set learning rate."""
lr_each_step = []
total_steps = steps_per_epoch * total_epochs
warmup_steps = steps_per_epoch * warmup_epochs
if warmup_steps != 0:
inc_each_step = (float(lr_max) - float(lr_init)) / float(warmup_steps)
else:
inc_each_step = 0
lr_value = lr_max
for i in range(total_steps):
if i <= warmup_steps:
lr_value = float(lr_init) + inc_each_step * float(i)
else:
if i // steps_per_epoch in epoch_step and i % steps_per_epoch == 0:
lr_value *= 0.1
if lr_value < 0.0:
lr_value = 0.0
lr_each_step.append(lr_value)
lr_each_step = np.array(lr_each_step).astype(np.float32)
learning_rate = lr_each_step[global_step:]
return learning_rate
0% or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment